//EXERCICE 1
//1.
function [m,n]=estim(X)
    m=mean(X)
    n=length(X)
endfunction

//2.a.
X=grand(100,1,'bin',1,0.25);
//2.b.
estim(X)//Retourne uniquement la moyenne empirique
[xbar,n]=estim(X)//Retourne les données voulues


//EXERCICE 2
//1.
cdfnor('X',0,1,0.975,0.025)//Retourne le quantile d'ordre 0.975 de la gaussienne centrée réduite

//2.a.
X=fscanfMat(TMPDIR + 'genX1.txt')//si le fichier a été enregistré dans le répertoire temporaire, à adapter

//2.b.
[xbar,n]=estim(X)//xbar est un estimateur de la moyenne, et n la taille de l'échantillon

//3.a.
function a=quantile(n,alpha)
    a=cdfnor('X',0,sqrt(2/n),alpha+(1-alpha)/2,(1+alpha)/2-alpha)
endfunction

//3.b.
[xbar-quantile(n,0.95),xbar+quantile(n,0.95)]

//4.
function I=intervExa(k,X,alpha)
    X=X(1:k)//On réduit X à ses k premières valeurs
    xbar=estim(X)
    I=[xbar-quantile(k,alpha),xbar+quantile(k,alpha)]
endfunction

I=zeros(n,2);
for k=1:n
    I(k,:)=intervExa(k,X,0.9);
end

plot2d([1:n]',[I,(I(:,1)+I(:,2))/2],style=[1,1,5])//Tracé de l'intervalle de confiance en noir, avec son milieu (l'estimateur de la moyenne) en rouge

//5.
N=1000;n=100;
X=grand(n,N,'nor',0,sqrt(2));
p=0;
for k=1:N
    I=intervExa(n,X(:,k),0.95);
    if I(1)<0 & I(2)>0 then
        p=p+1/N;
    end
end
p//Proportion d'intervalles de confiance contenant effectivement la moyenne


//EXERCICE 3
//1.
X=fscanfMat(TMPDIR + 'genX2.txt')

//2.
function I=intervExc(X,alpha)
    [xbar,n]=estim(X);
    I=[xbar-1/(2*sqrt(n*(1-alpha))),xbar+1/(2*sqrt(n*(1-alpha)))];
endfunction

//3.
function I=intervAsy(X,alpha)
    [xbar,n]=estim(X);
    I=[xbar-cdfnor('X',0,1,alpha+(1-alpha)/2,(1+alpha)/2-alpha)/(2*sqrt(n)),xbar+cdfnor('X',0,1,alpha+(1-alpha)/2,(1+alpha)/2-alpha)/(2*sqrt(n))];
endfunction

//4.
intervExc(X,0.9)
intervAsy(X,0.9)
//Tracons un peu les choses en simulant un échantillon plus grand
X=grand(500,1,'bin',1,0.75);
I=zeros(length(X),2);J=I;
for k=1:length(X)
    I(k,:)=intervExc(X(1:k),0.9);
    J(k,:)=intervAsy(X(1:k),0.9);
end
K=ones(length(X),1)*0.75

plot2d([1:length(X)]',[I,J,K],style=[2,2,5,5,1])//En bleu l'intervalle par excès, en rouge l'intervalle asymptotique, en noir le paramètre réel à estimer


//EXERCICE 4
//1.
X=zeros(10000,1);
U=rand(10000,1);//Génération de 10000 lois uniformes sur [0,1]
for k=1:10000
    X(k)=cdfnor('X',0,1,U(k),1-U(k));
end
histplot(100,X)

//2.a.
function Y=gen_chi2(k)//Génère une v.a. de loi chi2(k)
    X=grand(1,k,'nor',0,1);
    Y=sum(X.^2)
endfunction

k=2;//par exemple
Y=zeros(10000,1);
for i=1:10000
    Y(i)=gen_chi2(k);
end
histplot(100,Y);
Yref=grand(10000,1,'chi',k);histplot(100,Yref)//pour comparaison

//2.b.
function Y=gen_student(k)//Génère une v.a. de loi T(k)
    X1=grand(1,1,'nor',0,1);
    X2=gen_chi2(k);
    Y=X1/sqrt(X2/k);
endfunction

k=5;//par exemple
Y=zeros(10000,1);
for i=1:10000
    Y(i)=gen_student(k);
end
histplot(100,Y);
